\begin{tikzpicture}[
  scale                      = 0.9,
  align                      = center,
  edge from parent/.style    = {draw, ->,
                                >={Stealth[width=6pt,length=9pt]}},
  level 1/.style             = {level distance=18mm},
  level 2/.style             = {level distance=20mm},
  level 3/.style             = {level distance=20mm},
  level 4/.style             = {level distance=20mm},
  every node/.style          = {scale=0.9, shape=rectangle,
                                fill=AbstractDescrNode,
                                draw=DartDescNodeBorder,
                                text=black, line width=0.8mm},
  StubNode/.style            = {dashed},
  MatchedNode/.style         = {draw=AbstractDescrNodeMatchedBorder},
  HandEdge/.style            = {draw, ->,
                                >={Stealth[width=6pt,length=9pt]}},
  CSharpNode/.style          = {draw=AbstractDescrNodeMatchedBorder}
]
  \Tree [.\node{DartDescr1};
            [.\node(RightExpr){DartDescr2};
                [.\node[StubNode](LeftStub){
                  StubDartDescr \\
                  \footnotesize{
                    $\left\{
                      \text{Stamp} == \text{'\textbf{AAA}'}
                    \right\}$
                  }
                };]
                [.\node{DartDescr3};
                    [.\node{DartDescr4};
                        [.\node[StubNode]{
                          StubDartDescr
                          \\ \footnotesize{
                               $\left\{
                                 \text{Stamp} == \text{'\textbf{BBB}'}
                               \right\}$
                             }
                           };]]]]]
   \begin{scope}[xshift=90mm]
    \Tree [.\node{DartDescr1};
              [.\node(RightExpr){DartDescr2};
              [.\node[yshift=-30mm]{RoslynExprAdapter\\\\
                \begin{tikzpicture}
                \begin{scope}
                  \draw node [CSharpNode]                         (CSDescr7) {CSDescr3};
                  \draw node [CSharpNode, below=10mm of CSDescr7] (CSDescr5) {CSDescr6};
                  \path[->] (CSDescr7)  edge[HandEdge, midway, below, sloped] (CSDescr5);
                \end{scope}
                  \end{tikzpicture}};]
                  [.\node{DartDescr3};
                      [.\node{DartDescr4};
                      [.\node[yshift=-30mm]{RoslynExprAdapter\\\\
                      \begin{tikzpicture}
                        \begin{scope}
                        \draw node [CSharpNode]                         (CSDescr7) {CSDescr7};
                    \draw node [CSharpNode, below=10mm of CSDescr7] (CSDescr5) {CSDescr5};
                    \path[->] (CSDescr7)  edge[HandEdge, midway, below, sloped] (CSDescr5);
                  \end{scope}
                  \end{tikzpicture}};]]]]]
  \end{scope}
\end{tikzpicture}
